/* Problem URL: https://codeforces.com/problemset/problem/2084/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;
    vi a(n);
    vi b(n);
    cin >> a >> b;

    int c = 0;
    int p;

    map<pair<int, int>, int> s;
    rep(i, n) {
        s[{a[i], b[i]}] = i;
        if (a[i] == b[i]) {
            c++;
            p = i;
        }
    }

    if ((c > 0 && (~n & 1)) || (c != 1 && (n & 1))) {
        cout << "-1\n";
        return;
    }

    rep(i, n) {
        if (!s.count({b[i], a[i]})) {
            cout << "-1\n";
            return;
        }
    }

    V<pair<int, int>> ans;

    if (c && p != (n >> 1)) {
        ans.emplace_back(p + 1, (n >> 1) + 1);
        swap(a[p], a[n >> 1]);
        swap(b[p], b[n >> 1]);
        swap(s[{a[p], b[p]}], s[{a[n >> 1], b[n >> 1]}]);
    }

    rep(i, n >> 1) {
        int rev = n - i - 1;
        auto itr = s.find({b[i], a[i]});

        if (itr->second == rev) {
            continue;
        }

        ans.emplace_back(itr->second + 1, rev + 1);
        auto itr2 = s.find({a[rev], b[rev]});
        swap(a[rev], a[itr->second]);
        swap(b[rev], b[itr->second]);
        swap(itr->second, itr2->second);
    }

    cout << ans.size() << '\n';
    repv(i, ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
